/* GetCurrentHwProfile.cpp */
/* see "http://msdn.microsoft.com/library/default.asp?url=/library/en-us/sysinfo/base/getcurrenthwprofile.asp */

#define WIN32_LEAN_AND_MEAN	 /* Exclude rarely-used stuff from Windows headers */
#define _WIN32_WINNT 0x400  /* I don't know what this is, but it is needed by winbase.h */
#include <windows.h>
#include <stdio.h>
#include <tchar.h>

int main(void)
{
   HW_PROFILE_INFO HwProfInfo;
   printf( "rem  Redirect the output of this program into a .bat file, and then\n"
           "rem  'call' the .bat file to set an environment variable with the name\n"
           "rem  of the current hardware profile.\n"
           "rem  (Uncopyrighted,  by Dave Burton  <dave@burtonsys.com>  7-Sep-2005)\n");
   if (!GetCurrentHwProfile(&HwProfInfo))
   {
      printf( "rem  ERROR: GetCurrentHwProfile failed with error %lx\n", GetLastError() );
      return 1;
   }
   /* printf( "rem DockInfo = %d\n", HwProfInfo.dwDockInfo ); */
   /* printf( "rem Profile Guid = %s\n", HwProfInfo.szHwProfileGuid ); */
   printf( "set HWPROFILE=%s\n", HwProfInfo.szHwProfileName );
   /* note that this won't work, because it only sets the environment variable in the child process context:  SetEnvironmentVariable( "HWPROFILE", HwProfInfo.szHwProfileName ); */
   return 0;
}

